﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Net;
using System.IO;
using System.Collections.Specialized;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;

namespace alimtalk
{
    /// <summary>
    /// 알림톡 연동 
    /// C# 은 JSon 파싱이 따로 없기 때문에 외부 패키지 설치 하여 처리해야함 
    /// 여기서는 Newtonsoft.Json 사용 
    /// nuget 패키지 관리자 콘솔에서 Install-Package Newtonsoft.Json -Version 12.0.3 설치 후 
    /// using Newtonsoft.Json;    
    /// using Newtonsoft.Json.Linq; 
    /// 추가 하여 Json 파싱 하기 바람 
    /// Newtonsoft Json 파싱 방법은 구글에 검색 하여 진행 바랍니다. 
    /// </summary>
    public partial class Form1 : Form
    {
        string userID = "";
        string plusid = "@";
        string apikey = "";

        string token = "";
        string AdminPhone = "";
        string authnum = "";
        string categorycode = "";
        string senderkey = "";
        string tpl_code = "";
        string tpl_name = "";
        string tpl_content = "";
        string tpl_button = "";
        string senderphone = "";
        string senddate = "";
        string receiver_1 = "";
        string recvname_1 = "홍길동";
        string subject_1 = "제목";
        string message_1 = "테스트 입니다.";
        string button_1 = "{\"button\":[{\"name\":\"배송조회(DS)\",\"linkType\":\"DS\"}]}";
        string receiver_2 = "01075709618";
        string recvname_2 = "홍길동2";
        string subject_2 = "제목";
        string message_2 = "테스트 입니다.";
        string button_2 = "{\"button\":[{\"name\":\"배송조회(DS)\",\"linkType\":\"DS\"}]}";
        string mid = "";
        private string SendApiFileUpload(string url, string post)
        {
            WebRequest request = WebRequest.Create(url);
            // Set the Method property of the request to POST.  
            request.Method = "POST";

            // Create POST data and convert it to a byte array.             
            byte[] byteArray = Encoding.UTF8.GetBytes(post);

            // Set the ContentType property of the WebRequest.  
            request.ContentType = "application/x-www-form-urlencoded";
            // Set the ContentLength property of the WebRequest.  
            request.ContentLength = byteArray.Length;

            // Get the request stream.  
            Stream dataStream = request.GetRequestStream();
            // Write the data to the request stream.  
            dataStream.Write(byteArray, 0, byteArray.Length);
            // Close the Stream object.  
            dataStream.Close();

            // Get the response.  
            WebResponse response = request.GetResponse();
            // Display the status.  
            Console.WriteLine(((HttpWebResponse)response).StatusDescription);
            string Result = "";
            // Get the stream containing content returned by the server.  
            // The using block ensures the stream is automatically closed.
            using (dataStream = response.GetResponseStream())
            {
                // Open the stream using a StreamReader for easy access.  
                StreamReader reader = new StreamReader(dataStream);
                // Read the content.  
                string responseFromServer = reader.ReadToEnd();
                Result = responseFromServer;
                // Display the content.  
                Console.WriteLine(responseFromServer);
            }

            // Close the response.  
            response.Close();

            return Result;
        }

        public Form1()
        {
            InitializeComponent();
        }


        //-----------------------------------------------------------------------------------
        //알림톡 토큰 생성
        //-----------------------------------------------------------------------------------
        //API호출 URL의 유효시간을 결정하며 URL 의 구성중 "30"은 요청의 유효시간을 의미하며, "s"는 y(년), m(월), d(일), h(시), i(분), s(초) 중 하나이며 설정한 시간내에서만 토큰이 유효합니다.
        //운영중이신 보안정책에 따라 토큰의 유효시간을 특정 기간만큼 지정할 경우 매번 호출할 필요없이 해당 유효시간내에 재사용 가능합니다.
        //주의하실 점은 서버를 여러대 운영하실 경우 토큰은 서버정보를 포함하므로 각 서버에서 생성된 토큰 문자열을 사용하셔야 하며 토큰 문자열을 공유해서 사용하실 수 없습니다.
        private void button1_Click(object sender, EventArgs e)
        {

            //'apikey' => '발급받은 API 키',
            //'userid' => '사용중이신 아이디'
            string postData = string.Format("apikey={0}&userid={1}", apikey, userID);
            string rtn = SendApiFileUpload("https://kakaoapi.aligo.in/akv10/token/create/30/s/", postData);
            JObject jobj = JObject.Parse(rtn);
            if (jobj["code"].ToString().Equals("0"))
            {
                token = "";
                token = jobj["urlencode"].ToString();
            }

            //예제 
            // -- 성공 -- 
            //{
            //    "code": 0
            //    "message": "정상적으로 생성하였습니다."
            //    "token": z8eb77c428c46d04cf7db29U5vakS6dZB7bfAP + vBjX + RfWjtfNcQ ==
            //    "urlencode": z8eb77c428c46d04cf7db29U5vakS6dZB7bfAP % 2BvBjX % 2BRfWjtfNcQ % 3D % 3D
            //}
            //--오류 
            //{
            //    "code": 0 이외의 모든 코드 
            //    "message": "에러메세지"
            //}
        }

        //-----------------------------------------------------------------------------------
        //발신프로필 인증요청
        //---------------------------------------------------------------------------------- -
        //알림톡 및 친구톡을 전송하기 위해서는 반드시 플러스 친구를 인증한 후 진행해야 합니다.
        //보유한 플러스 친구 계정이 없을경우(https://center-pf.kakao.com ) 에서 등록하신 후 진행 가능합니다.
        private void btnAuthchannel_Click(object sender, EventArgs e)
        {

            //'apikey'      => '발급받은 API 키',
            //'userid'      => '사용중이신 아이디',
            //'token'       => '생성한 토큰 문자열',
            //'plusid'      => '@인증요청할 발신 프로필 아이디',
            //'phonenumber' => '발신프로필 관리자 휴대폰'

          //  button1_Click(null, null);

            string postData = string.Format("apikey={0}&userid={1}&token={2}&plusid={3}&phonenumber={4}", apikey, userID,token, plusid, AdminPhone);
            string rtn = SendApiFileUpload("https://kakaoapi.aligo.in/akv10/profile/auth/", postData);
            JObject jobj = JObject.Parse(rtn);

            // 예제
            // -- 성공 -- 
            //{
            //    "code": 0
            //    "message": "정상적으로 호출하였습니다."
            //}
            //
            //--오류 
            //{
            //    "code": 0 이외의 모든 코드 
            //    "message": "에러메세지"
            //}


        }

        //-----------------------------------------------------------------------------------
        //카테고리 조회
        //---------------------------------------------------------------------------------- -
        //알림톡 발신프로필 심사요청시 사용가능한 카테고리 정보 입니다. "thirdBusinessType" 의 code 를 기입하시면 됩니다.
        private void btncategory_Click(object sender, EventArgs e)
        {

            //'apikey' => '발급받은 API 키',
            //'userid' => '사용중이신 아이디',
            //'token'  => '생성한 토큰 문자열'
          //  button1_Click(null, null);
            string postData = string.Format("apikey={0}&userid={1}&token={2}", apikey, userID, token);
            string rtn = SendApiFileUpload("https://kakaoapi.aligo.in/akv10/category/", postData);
            JObject jobj2 = JObject.Parse(rtn);


            //예제
            //--성공-- 
            //{
            //        "code": 0
            //        "message": "정상적으로 호출하였습니다."
            //        "data": {
            //                firstBusinessType: [{ "parentCode": "", "code":"001", "name":"건강"}...],
            //                secondBusinessType: [{ "parentCode": "001", "code":"001001", "name":"병원"}...],
            //                thirdBusinessType: [{ "parentCode": "0010001", "code":"00100010001", "name":"종합병원"}...]
            //        }
            //}
            //
            //--오류 
            //{
            //    "code": 0 이외의 모든 코드 
            //    "message": "에러메세지"
            //}

        }


        //-----------------------------------------------------------------------------------
        //발신프로필 등록 요청
        //-----------------------------------------------------------------------------------
        //알림톡 및 친구톡을 전송하기 위해서는 플러스 친구를 심사요청 후 진행해야 하며
        //다음-카카오측의 심사요청 결과에 따라 거부되어 재심사 요청이 발생할 수 있습니다.
        private void btnauthfriend_Click(object sender, EventArgs e)
        {
            //'apikey'    => '발급받은 API 키', 
            //'userid'    => '사용중이신 아이디', 
            //'token'     => '생성한 토큰 문자열', 
            //'plusid'    => '@인증요청할 발신 프로필 아이디', 
            //'authnum'   => '카카오톡으로 전송된 인증번호',
            //'phonenumber'   => '발신프로필 관리자 휴대폰',
            //'categorycode'  => '카테고리 코드',
           // button1_Click(null, null);
            string postData = string.Format("apikey={0}&userid={1}&token={2}&plusid={3}&authnum={4}&phonenumber={5}&categorycode={6}", apikey, userID, token, plusid,textBox1.Text,AdminPhone,textBox2.Text);
            string rtn = SendApiFileUpload("https://kakaoapi.aligo.in/akv10/profile/add/", postData);
            JObject jobj = JObject.Parse(rtn);

            //예제
            // --성공-- 
            //{
            //    "code": 0
            //    "message": "정상적으로 호출하였습니다."
            //    "data": [{
            //        "senderKey": "XXXXXXXXXXXXXXXXXXXXXXXXXX",
            //        "uuid": "@xxxx",
            //        "name": "xxxx",
            //        "status": "A",
            //        "profileStat": "A",
            //        "cdate": "2020-02-11 15:54:50",
            //        "udate": "2020-02-11 15:54:50",
            //        "catCode": "00000000000",
            //        "alimUseYn": false
            //    }]
            //}
            //--오류 
            //{
            //    "code": 0 이외의 모든 코드 
            //    "message": "에러메세지"
            //}
        }

        //-----------------------------------------------------------------------------------
        //등록된 플러스친구 리스트
        //-----------------------------------------------------------------------------------
        //등록된 플러스 친구 목록을 조회합니다.
        private void btnlist_Click(object sender, EventArgs e)
        {
            //'apikey'    => '발급받은 API 키',
            //'userid'    => '사용중이신 아이디',
            //'token'     => '생성한 토큰 문자열',
            //'plusid'    => '플러스친구 아이디(@포함)',
            //'senderkey' => '발신프로필키'
           // button1_Click(null, null);
            string postData = string.Format("apikey={0}&userid={1}&token={2}&plusid={3}&senderkey={4}", apikey, userID, token,plusid,senderkey);
            string rtn = SendApiFileUpload("https://kakaoapi.aligo.in/akv10/profile/list/", postData);
            JObject jobj = JObject.Parse(rtn);

            //예제
            //--성공--
            //{
            // "code": 0
            //     "message": "정상적으로 호출하였습니다."
            //     "list": [{
            //         "senderKey": "000000000000000000000000000000000000",
            //         "license": "http://mud-kage.kakao.com/dn/0000/0000/00000000000000000/img.png",
            //         "catCode": "00000000000",
            //         "alimUseYn": false,
            //         "cdate": "2020-02-11 15:54:50",
            //         "name": "테스트",
            //         "profileStat": "A",
            //         "licenseNum": "테스트",
            //         "udate": "2020-02-11 15:54:50",
            //         "uuid": "@test",
            //         "status": "A"
            //     }]
            // }
            //--오류 
            //{
            //    "code": 0 이외의 모든 코드 
            //    "message": "에러메세지"
            //}
        }

        //-----------------------------------------------------------------------------------
        //등록된 템플릿 리스트
        //-----------------------------------------------------------------------------------
        //등록된 템플릿 목록을 조회합니다.템플릿 코드가 D 나 P 로 시작하는 경우 공유 템플릿이므로 삭제 불가능 합니다.
        private void btntempletelist_Click(object sender, EventArgs e)
        {
            //'apikey'    => '발급받은 API 키',
            //'userid'    => '사용중이신 아이디',
            //'token'     => '생성한 토큰 문자열',
            //'senderkey' => '발신프로필키',
            //'tpl_code'  => '조회할 템플릿 코드 필수아님'
            //button1_Click(null, null);
            string postData = string.Format("apikey={0}&userid={1}&token={2}&senderkey={3}&tpl_code={4}", apikey, userID, token,senderkey, tpl_code);
            string rtn = SendApiFileUpload("https://kakaoapi.aligo.in/akv10/template/list/", postData);
            JObject jobj = JObject.Parse(rtn);

            //예제
            //--성공--
            //{
            // "code": 0
            //     "message": "정상적으로 호출하였습니다."
            //     "list": [{
            //         "templtContent": "#{고객명}님께서 주문하신 물품이\r\n배송완료 되었습니다.\r\n구매확정 부탁드립니다.",
            //         "templtName": "배송완료 안내",
            //         "status": "R",
            //         "inspStatus": "APR",
            //         "senderKey": "000000000000000000000000000000000000",
            //         "buttons": [
            //             {
            //                 "ordering": "1",
            //                 "name": "구매확정바로가기",
            //                 "linkType": "WL",
            //                 "linkTypeName": "웹링크",
            //                 "linkMo": "http://#{구매확정바로가기}",
            //                 "linkPc": "http://#{구매확정바로가기}",
            //                 "linkIos": "",
            //                 "linkAnd": ""
            //             }
            //         ],
            //         "cdate": "2018-12-28 17:21:40",
            //         "templtCode": "P000004",
            //         "comments": []
            //     }],
            //     "info": {
            //         "REG": 0,
            //         "REQ": 0,
            //         "APR": 1,
            //         "REJ": 0
            //     }
            // }
            //--오류 
            //{
            //    "code": 0 이외의 모든 코드 
            //    "message": "에러메세지"
            //}
        }

        private void btncreatetemplete_Click(object sender, EventArgs e)
        {
            //'apikey'        => '발급받은 API 키', 
            //'userid'        => '사용중이신 아이디', 
            //'token'         => '생성한 토큰 문자열', 
            //'senderkey'   => '발신프로필키', 
            //'tpl_name'    => '등록할 템플릿 명',
            //'tpl_content' => '등록할 템플릿 컨텐츠',
            //'tpl_button'  => '{"button":[{"name":"테스트 버튼","linkType":"DS"}]}'
            //button1_Click(null, null);
            string postData = string.Format("apikey={0}&userid={1}&token={2}&senderkey={3}&tpl_name={4}&tpl_content={5}&tpl_button={6}", apikey, userID, token, senderkey, tpl_name, tpl_content, tpl_button);
            string rtn = SendApiFileUpload("https://kakaoapi.aligo.in/akv10/template/add/", postData);
            JObject jobj = JObject.Parse(rtn);

            //예제
            //--성공--
            //{
            // "code": 0
            //     "message": "정상적으로 템플릿을 생성하였습니다."
            //     "data": {
            //     "senderKey": "XXXXXXXXXXXXXX",
            //         "templtContent": "등록한 템플릿 컨텐츠",
            //         "templtName": "등록한 템플릿 명",
            //         "cdate": "2020-02-11 15:54:50",
            //         "comments": [],
            //         "buttons": [
            //             {
            //                 "ordering": "1",
            //                 "name": "웹링크",
            //                 "linkType": "WL",
            //                 "linkTypeName": "웹링크",
            //                 "linkMo": "http://#{버튼변수}",
            //                 "linkPc": "http://#{버튼변수}",
            //                 "linkIos": "",
            //                 "linkAnd": ""
            //             }
            //         ],
            //         "templtCode": XXXXXXXX
            //         "udate": 
            //         "inspStatus": REG
            //         "status": R
            //     }
            // }
            //--오류 
            //{
            //    "code": 0 이외의 모든 코드 
            //    "message": "에러메세지"
            //}
        }

        private void btntempletemod_Click(object sender, EventArgs e)
        {
            //'apikey'        => '발급받은 API 키',
            //'userid'        => '사용중이신 아이디',
            //'token'         => '생성한 토큰 문자열',
            //'senderkey'     => '발신프로필키',
            //'tpl_code'      => '템플릿 코드',
            //'tpl_name'      => '템플릿 이름',
            //'tpl_content'   => '템플릿 내용',
            //'tpl_button'    => '{"button":[{"name":"테스트 버튼","linkType":"DS"}]}',
            //button1_Click(null, null);
            string postData = string.Format("apikey={0}&userid={1}&token={2}&senderkey={3}&tpl_code={4}&tpl_name={5}&tpl_content={6}&tpl_button={7}", apikey, userID, token, senderkey, tpl_code, tpl_name, tpl_content, tpl_button);
            string rtn = SendApiFileUpload("https://kakaoapi.aligo.in/akv10/template/modify/", postData);
            JObject jobj = JObject.Parse(rtn);

            //예제
            //--성공--
            //{
            //     "code": 0
            //     "message": "정상적으로 템플릿을 수정하였습니다."
            //     "data": {
            //     "senderKey": "XXXXXXXXXXXXXX",
            //         "templtContent": "수정한 템플릿 컨텐츠",
            //         "templtName": "수정한 템플릿 명",
            //         "cdate": "2020-02-11 15:54:50",
            //         "comments": [],
            //         "buttons": [
            //             {
            //                 "ordering": "1",
            //                 "name": "웹링크",
            //                 "linkType": "WL",
            //                 "linkTypeName": "웹링크",
            //                 "linkMo": "http://#{버튼변수}",
            //                 "linkPc": "http://#{버튼변수}",
            //                 "linkIos": "",
            //                 "linkAnd": ""
            //             }
            //         ],
            //         "templtCode": XXXXXXXX
            //         "udate": 
            //         "inspStatus": REG
            //         "status": R
            //    }
            // }
            //--오류 
            //{
            //    "code": 0 이외의 모든 코드 
            //    "message": "에러메세지"
            //}
        }

        private void btntempletedelete_Click(object sender, EventArgs e)
        {
            //'apikey'        => '발급받은 API 키',
            //'userid'        => '사용중이신 아이디',
            //'token'         => '생성한 토큰 문자열',
            //'senderkey'     => '발신프로필키',
            //'tpl_code'      => '템플릿 코드'
            //button1_Click(null, null);
            string postData = string.Format("apikey={0}&userid={1}&token={2}&senderkey={3}&tpl_code={4}", apikey, userID, token, senderkey, tpl_code);
            string rtn = SendApiFileUpload("https://kakaoapi.aligo.in/akv10/template/del/", postData);
            JObject jobj = JObject.Parse(rtn);

            // 예제
            // -- 성공 -- 
            //{
            //    "code": 0
            //    "message": "정상적으로 템플릿을 삭제 하였습니다."
            //}
            //
            //--오류 
            //{
            //    "code": 0 이외의 모든 코드 
            //    "message": "에러메세지"
            //}
        }

        private void btntempletereq_Click(object sender, EventArgs e)
        {
            //'apikey'        => '발급받은 API 키',
            //'userid'        => '사용중이신 아이디',
            //'token'         => '생성한 토큰 문자열',
            //'senderkey'     => '발신프로필키',
            //'tpl_code'      => '템플릿 코드'
            //button1_Click(null, null);
            string postData = string.Format("apikey={0}&userid={1}&token={2}&senderkey={3}&tpl_code={4}", apikey, userID, token, senderkey, tpl_code);
            string rtn = SendApiFileUpload("https://kakaoapi.aligo.in/akv10/template/request/", postData);
            JObject jobj = JObject.Parse(rtn);

            // 예제
            // -- 성공 -- 
            //{
            //    "code": 0
            //    "message": "검수요청을 하였습니다."
            //}
            //
            //--오류 
            //{
            //    "code": 0 이외의 모든 코드 
            //    "message": "에러메세지"
            //}
        }


        //-----------------------------------------------------------------------------------
        //알림톡 전송
        //-----------------------------------------------------------------------------------
        //버튼의 경우 템플릿에 버튼이 있을때만 버튼 파라메더를 입력하셔야 합니다.
        //버튼이 없는 템플릿인 경우 버튼 파라메더를 제외하시기 바랍니다.
        private void btnSend_Click(object sender, EventArgs e)
        {
            //'apikey'      => '발급받은 API 키', 
            //'userid'      => '사용중이신 아이디', 
            //'token'       => '생성한 토큰 문자열', 
            //'senderkey'   => '발신프로필키', 
            //'tpl_code'    => '전송할 템플릿 코드',
            //'sender'      => '발신자번호',
            //'senddate'    => date("YmdHis", strtotime("+10 minutes")),
            //'receiver_1'  => '첫번째 알림톡을 전송받을 휴대폰 번호',
            //'recvname_1'  => '첫번째 알림톡을 전송받을 사용자 명',
            //'subject_1'   => '첫번째 알림톡을 제목',
            //'message_1'   => '첫번째 템플릿내용을 기초로 작성된 전송할 메세지 내용',
            //'button_1'    => '{"button":[{"name":"테스트 버튼","linkType":"DS"}]}', // 템플릿에 버튼이 없는경우 제거하시기 바랍니다.
            //'receiver_2'  => '첫번째 알림톡을 전송받을 휴대폰 번호',
            //'recvname_2'  => '첫번째 알림톡을 전송받을 사용자 명',
            //'subject_2'   => '첫번째 알림톡을 제목',
            //'message_2'   => '첫번째 템플릿내용을 기초로 작성된 전송할 메세지 내용',
            //'button_2'    => '{"button":[{"name":"테스트 버튼","linkType":"DS"}]}' // 템플릿에 버튼이 없는경우 제거하시기 바랍니다.
            //button1_Click(null, null);
            StringBuilder sb = new StringBuilder();
            sb.Append("apikey={0}&");
            sb.Append("userid={1}&");
            sb.Append("token={2}&");
            sb.Append("senderkey={3}&");
            sb.Append("tpl_code={4}&");
            sb.Append("sender={5}&");
            sb.Append("senddate={6}&");
            sb.Append("receiver_1={7}&");
            sb.Append("recvname_1={8}&");
            sb.Append("subject_1={9}&");
            sb.Append("message_1={10}&");
            sb.Append("button_1={11}&");
            //sb.Append("receiver_2={12}&");
            //sb.Append("recvname_2={13}&");
            //sb.Append("subject_2={14}&");
            //sb.Append("message_2={15}&");
            //sb.Append("button_2={16}");



           // -----------------------------------------------------------------
           // 치환자 변수에 대한 처리
           // ---------------------------------------------------------------- -

           // 등록된 템플릿이 "#{이름}님 안녕하세요?" 일경우
           // 실제 전송할 메세지(message_x) 에 들어갈 메세지는
           // "홍길동님 안녕하세요?" 입니다.

           // 카카오톡에서는 전문과 템플릿을 비교하여 치환자이외의 부분이 일치할 경우
           // 정상적인 메세지로 판단하여 발송처리 하는 관계로
           // 반드시 개행문자도 템플릿과 동일하게 작성하셔야 합니다.

           // 예제: message_1 = "홍길동님 안녕하세요?"

           // ---------------------------------------------------------------- -
           // 버튼타입이 WL일 경우(웹링크)
           // -----------------------------------------------------------------
           // 링크정보는 다음과 같으며 버튼도 치환변수를 사용할 수 있습니다.
           // { "button":[{"name":"버튼명","linkType":"WL","linkP":"https://www.링크주소.com/?example=12345", "linkM": "https://www.링크주소.com/?example=12345"}]}

           // -----------------------------------------------------------------
           // 버튼타입이 AL 일 경우(앱링크)
           // -----------------------------------------------------------------
           // {"button":[{"name":"버튼명","linkType":"AL","linkI":"https://www.링크주소.com/?example=12345", "linkA": "https://www.링크주소.com/?example=12345"}]}

           // -----------------------------------------------------------------
           // 버튼타입이 DS 일 경우(배송조회)
           // -----------------------------------------------------------------
           // {"button":[{"name":"버튼명","linkType":"DS"}]}

           // -----------------------------------------------------------------
           // 버튼타입이 BK 일 경우(봇키워드)
           // -----------------------------------------------------------------
           // {"button":[{"name":"버튼명","linkType":"BK"}]}

           // -----------------------------------------------------------------
           // 버튼타입이 MD 일 경우(메세지 전달)
           // -----------------------------------------------------------------
           // {"button":[{"name":"버튼명","linkType":"MD"}]}

           // -----------------------------------------------------------------
           // 버튼이 여러개 인경우(WL + DS)
           // -----------------------------------------------------------------
           // {"button":[{"name":"버튼명","linkType":"WL","linkP":"https://www.링크주소.com/?example=12345", "linkM": "https://www.링크주소.com/?example=12345"}, {"name":"버튼명","linkType":"DS"}]}


            string postData = string.Format(sb.ToString(), apikey, userID, token, senderkey, tpl_code,senderphone,senddate, receiver_1,recvname_1,subject_1,message_1,button_1); //, receiver_2, recvname_2, subject_2, message_2, button_2
            string rtn = SendApiFileUpload("https://kakaoapi.aligo.in/akv10/alimtalk/send/", postData);
            JObject jobj = JObject.Parse(rtn);

            // 예제
            // -- 성공 -- 
            //{
            //     "code": 0
            //     "message": "성공적으로 전송요청 하였습니다."
            //     "info" : [{
            //             "type": "AT",
            //              "mid": "XXXXXXXX",
            //             "current": 0,
            //             "unit": 0,
            //             "total": 0,
            //             "scnt": 0,
            //             "fcnt": 0
            //             }]
            // }
            //--오류 
            //{
            //    "code": 0 이외의 모든 코드 
            //    "message": "에러메세지"
            //}
        }

        //-----------------------------------------------------------------------------------
        //전송내역조회
        //-----------------------------------------------------------------------------------
        //최근 요청및 처리된 전송내역을 조회하실 수 있습니다.
        //사이트내 전송결과조회 페이지와 동일한 내역이 조회되며, 날짜기준으로 조회가 가능합니다.
        //발신번호별 조회기능은 제공이 되지 않습니다.
        //조회시작일을 지정하실 수 있으며, 시작일 이전 몇일까지 조회할지 설정이 가능합니다.
        //조회시 최근발송내역 순서로 소팅됩니다.
        private void btnsendlist_Click(object sender, EventArgs e)
        {
            //'apikey'        => '발급받은 API 키',
            //'userid'        => '사용중이신 아이디',
            //'token'         => '생성한 토큰 문자열',
            //'page'          => '조회 페이지',
            //'limit'         => '페이지당 출력갯수',
            //'startdate'     => '조회시작일자',
            //'enddate'       => '조회마감일자'
            //button1_Click(null, null);
            string postData = string.Format("apikey={0}&userid={1}&token={2}&page={3}&limit={4}&startdate={5}&enddate={6}", apikey, userID, token, 1, 50,"20200101","20200131");
            string rtn = SendApiFileUpload("https://kakaoapi.aligo.in/akv10/history/list/", postData);
            JObject jobj = JObject.Parse(rtn);

            // 예제
            // -- 성공 --    
            //{
            //       "code": 0
            //       "message": "정상적으로 호출하였습니다."
            //       "list": [{
            //              "mid": "123456788"
            //              "type": "AT"
            //              "sender": "025114560"
            //              "msg_count": "1"
            //              "reserve_date": "20200211155450"
            //              "reserve_state": "예약대기중"
            //              "mbody": "API 전송테스트 입니다."
            //              "reg_date": "2020-02-11 15:19:50"
            //           }]
            //       "currentPage": "1"
            //       "totalPage": "1"
            //       "totalCount": "1"
            //}
            //--오류 
            //{
            //    "code": 0 이외의 모든 코드 
            //    "message": "에러메세지"
            //}
        }

        //-----------------------------------------------------------------------------------
        //전송결과조회(상세)
        //-----------------------------------------------------------------------------------
        //최근 요청및 처리된 전송내역을 조회하실 수 있습니다.
        //사이트내 전송결과조회 페이지와 동일한 내역이 조회되며, 날짜기준으로 조회가 가능합니다.
        //발신번호별 조회기능은 제공이 되지 않습니다.
        //조회시작일을 지정하실 수 있으며, 시작일 이전 몇일까지 조회할지 설정이 가능합니다.
        //조회시 최근발송내역 순서로 소팅됩니다.
        private void btnsendreturn_Click(object sender, EventArgs e)
        {
            //'apikey'        => '발급받은 API 키',
            //'userid'        => '사용중이신 아이디',
            //'token'         => '생성한 토큰 문자열',
            //'mid'           => '메시지 고유ID',
            //'page'          => '발신프로필키',
            //'limit'         => '템플릿 코드',
            //'startdate'     => '조회시작일자',
            //'enddate'       => '조회마감일자'
            //button1_Click(null, null);
            string postData = string.Format("apikey={0}&userid={1}&token={2}&mid={3}&page={4}&limit={5}&startdate={6}&enddate={7}", apikey, userID, token, mid, 1, 50, "20200101", "20200131");
            string rtn = SendApiFileUpload("https://kakaoapi.aligo.in/akv10/history/detail/", postData);
            JObject jobj = JObject.Parse(rtn);

            // 예제
            // -- 성공 --          
            //   {
            //       "code": 0
            //       "message": "정상적으로 호출하였습니다."
            //       "list": [{
            //             "msgid": "123456788",
            //             "type": "AT",
            //             "sender": "025114560",
            //             "phone": "010XXXXXXXX",
            //             "status": "3",
            //             "reqdate": "2020-02-11 15:54:50",
            //             "sentdate": "2020-02-11 15:54:50",
            //             "rsltdate": "2020-02-11 15:54:50",
            //             "reportdate": "2020-02-11 15:54:50",
            //             "rslt": "U",
            //             "rslt_message": "메시지가 템플릿과 일치하지않음",
            //             "message": "API 전송테스트 입니다.",
            //             "button_json": "{}",
            //             "tpl_code": "XXXXXXX",
            //             "senderKey": "XXXXXXX",
            //             "smid": "0"
            //       }]
            //    "currentPage": "1",
            //    "totalPage": "1",
            //    "totalCount": "1"
            //}
            //--오류 
            //{
            //    "code": 0 이외의 모든 코드 
            //    "message": "에러메세지"
            //}
        }

        //-----------------------------------------------------------------------------------
        //발송가능건수
        //-----------------------------------------------------------------------------------
        //보유한 충전금 잔액으로 발송가능한 잔여건수를 문자구분(유형)별로 조회하실 수 있습니다.
        //SMS, LMS, MMS, ALT 로 발송시 가능한 잔여건수이며 남은 충전금을 문자유형별로 보냈을 경우 가능한 잔여건입니다.
        //예를들어 SMS_CNT : 11 , ALT_CNT : 15 인 경우 단문전송시 11건이 가능하고, 알림톡으로 전송시 15건이 가능합니다.
        private void btnSendCount_Click(object sender, EventArgs e)
        {
            //'apikey' => '발급받은 API 키',
            //'userid' => '사용중이신 아이디',
            //'token'  => '생성한 토큰 문자열'
            //button1_Click(null, null);
            string postData = string.Format("apikey={0}&userid={1}&token={2}", apikey, userID, token);
            string rtn = SendApiFileUpload("https://kakaoapi.aligo.in/akv10/heartinfo/", postData);
            JObject jobj = JObject.Parse(rtn);

            // 예제
            // -- 성공 --    
            //{
            //    "code": 1
            //    "message": ""
            //    "list" : {
            //                "SMS_CNT": 5555
            //                "LMS_CNT": 1930
            //                "MMS_CNT": 833
            //             }
            //}
            //--오류 
            //{
            //    "code": 0 이외의 모든 코드 
            //    "message": "에러메세지"
            //}
        }

        //-----------------------------------------------------------------------------------
        //예약문자 취소
        //-----------------------------------------------------------------------------------
        //API를 통해 예약한 내역을 전송취소할 수 있습니다.
        //예약취소는 발송전 5분이전의 문자만 가능합니다.
        private void btncancel_Click(object sender, EventArgs e)
        {
            //'apikey' => '발급받은 API 키',
            //'userid' => '사용중이신 아이디',
            //'token'  => '생성한 토큰 문자열',
            //'mid'    => '메시지 고유ID'
            //button1_Click(null, null);
            string postData = string.Format("apikey={0}&userid={1}&token={2}&mid={3}", apikey, userID, token,mid);
            string rtn = SendApiFileUpload("https://kakaoapi.aligo.in/akv10/cancel/", postData);
            JObject jobj = JObject.Parse(rtn);

            // 예제
            // -- 성공 -- 
            //{
            //    "code": 0
            //    "message": ""
            //}
            //
            //--오류 
            //{
            //    "code": 0 이외의 모든 코드 
            //    "message": "에러메세지"
            //}
        }
    }
}
